rc.d: Use stop_boot() function to really stop boot
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 5.6 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 TIMED AND TIMEDC REMOVED
16 ------------------------
17
18 timed(8) and timedc(8) have been removed because they are beyond
19 obsolete for setting the time.
20
21 LIBOPIE, LIBMD REMOVED
22 ----------------------
23
24 Removal of OPIE requires /etc/pam.d/ configs to be updated.
25
26 +-----------------------------------------------------------------------+
27 +         UPGRADING DRAGONFLY FROM 5.4 TO LATER VERSIONS                +
28 +-----------------------------------------------------------------------+
29
30 GCC50 REMOVED
31 -------------
32
33 The GCC50 compiler has been retired.  It has been replaced by a GCC80.
34 The default alternative compiler has stayed the same - GCC47.
35
36
37 PUFFS, PUTTER AND LIBREFUSE REMOVED
38 -----------------------------------
39
40 The puffs(4)/putter(4) subsystem has been removed, along with librefuse,
41 libpuffs, and the mount_psshfs(8) utility. All of these have never been
42 working correctly.
43
44 FFS_ROOT OPTION REMOVED
45 -----------------------
46
47 The FFS_ROOT kernel configuration option has been finally removed, after
48 having been a no-op since 4.9. That means users using a custom kernel
49 configuration file that still contains it need to remove the option from
50 that file.
51
52 +-----------------------------------------------------------------------+
53 +         UPGRADING DRAGONFLY FROM 5.2 TO LATER VERSIONS                +
54 +-----------------------------------------------------------------------+
55
56 DIGI, RP AND SI DRIVERS REMOVED
57 -------------------------------
58
59 The digi(4), rp(4) and si(4) serial drivers have been removed. None of
60 them were in our default kernel configuration file. The sicontrol(8)
61 utility was removed, too.
62
63 MKINITRD COMMAND REMOVED
64 ------------------------
65
66 The mkinitrd(8) command is removed and its functionality is replaced by
67 the new "initrd" make target.  After rebooting into the new world and
68 verifying everything works, execute "make initrd" to upgrade the rescue
69 tools and initrd image.
70
71 IPSEC, IPSEC_ESP AND IPSEC_DEBUG REMOVED FROM VKERNEL64 CONFIG
72 --------------------------------------------------------------
73
74 IPsec has been removed from the system. Of our standard kernel
75 configurations, only the virtual kernel one had it. People running
76 vkernels with configuration files derived from our VKERNEL64 will
77 have to remove these options manually.
78
79 +-----------------------------------------------------------------------+
80 +         UPGRADING DRAGONFLY FROM 5.0 TO LATER VERSIONS                +
81 +-----------------------------------------------------------------------+
82
83 VIRTIO_PCI REMOVED FROM KERNEL CONFIG
84 -------------------------------------
85
86 The "device virtio_pci" line in X86_64_GENERIC has been removed. People
87 with configuration files derived from it have to remove it manually.
88
89 VARIOUS 'R' COMMANDS AND DAEMONS REMOVED
90 ----------------------------------------
91
92 rcp(1), rlogin(1), rlogind(8), rsh(1) and rshd(8) have been removed.
93 For those that still need them, there is the net/bsdrcmds port.
94
95 VARIOUS FORMER OPTIONS REMOVED
96 ------------------------------
97
98 Various former kernel configuration options which had been no-ops for
99 some time were completely removed: SYSVMSG, SYSVSEM, SYSVSHM, P1003_1B,
100 _KPOSIX_VERSION and DSCHED_FQ. Users that have any of these still in
101 their kernel configuration files have to remove them.
102
103 BOOTSTRAPPING LIMITED FROM PRE 4.4
104 ----------------------------------
105
106 Upgrading to 5.1 and later versions now require at least 4.4 in
107 preparations for upcoming base compilers updates.
108
109 IF_PPP, PPPD, IF_FAITH, AND FAITHD REMOVED
110 ------------------------------------------
111
112 if_ppp has been replaced by "user ppp", i.e. ppp(8) and tun(4). It had
113 already been removed from our default kernel configuration before 5.0,
114 so only people with custom configurations based on earlier X86_64_GENERIC
115 will have to remove it manually.
116
117 The faith(4) interface has been completely removed after it had also
118 been removed from our default kernel configuration. 
119
120 +-----------------------------------------------------------------------+
121 +         UPGRADING DRAGONFLY FROM 4.8 TO LATER VERSIONS                +
122 +-----------------------------------------------------------------------+
123
124 FFS_ROOT OPTION DISABLED
125 ------------------------
126
127 The FFS_ROOT option has been made a no-op and will be completely removed
128 at some point in the future. Users with a custom kernel configuration
129 can remove this option from it now.
130
131 +-----------------------------------------------------------------------+
132 +         UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS                +
133 +-----------------------------------------------------------------------+
134
135 DSA OPENSSH KEYS DEPRECATED
136 ---------------------------
137
138 Note that DSA OpenSSH keys were deprecated in the 4.6 to 4.8 release. 
139 If you are upgrading from a release older than 4.8 and use DSA OpenSSH 
140 keys, please update your private/public key pair or risk locking 
141 yourself out.
142
143 AHC, AHD, AIC, NCV, NSP AND STG DRIVERS REMOVED
144 -----------------------------------------------
145
146 They were all in our X86_64_GENERIC kernel configuration file, along with
147 the AHC_REG_PRETTY_PRINT and AHD_REG_PRETTY_PRINT options, so any custom
148 configuration files derived from it need adjustment.
149
150 PORTAL FILE SYSTEM REMOVED
151 --------------------------
152
153 It has been broken for a long time now.
154
155 BINUTILS 2.27 REPLACES 2.24, PRIMARY
156 ------------------------------------
157
158 The oldest of the two versions of Binutils, version 2.24, was removed
159 and replaced with Binutils 2.27.  It becomes the primary version version
160 of binutils and version 2.25 becomes the alternate.
161
162 The accepted values of BINUTILSVER are now "binutils227" (default) and
163 "binutils225".  The building of Binutils 2.25 can be prevented by setting
164 NO_ALTBINUTILS=yes in make.conf.
165
166 COMPAT_43 KERNEL OPTION REMOVED
167 -------------------------------
168
169 It was commented out in our default configs for several years now, but
170 might still be present in custom configs created before Nov. 2011.
171
172 OPENSSL REMOVED
173 ---------------
174
175 OpenSSL has been removed from base and replaced with a private version of
176 LibreSSL.  The previously installed OpenSSL libraries, headers, and man
177 pages will remain on the system unless the "make upgrade" command is
178 specifically instructed to remove them.  To do this, define
179 REMOVE_OPENSSL_FILES for the upgrade command, e.g.
180 "make upgrade REMOVE_OPENSSL_FILES=yes"
181
182 28-Oct-2016: openssl has been replaced by ressl.  It is recommended that any
183 stale OpenSSL files be removed to avoid configuration scripts from using
184 the stale and potentially vulnerable version, but all binaries that are
185 dynamically linked to the OpenSSL libraries should be rebuilt first to
186 avoid breakage.
187
188 OPENSSH HPN REMOVED
189 -------------------
190
191 It has become too cumbersome to maintain HPN patches in OpenSSH in base.
192 To use OpenSSH in base remove HPN config, if you have added it.
193 Check files below for HPN config, see a few lines below.
194   /etc/ssh/ssh_config, /etc/ssh/sshd_config, ~/.ssh/config
195 sshd(8) will fail to start if HPN config is used.
196
197 NOTE: HPN config in sshd_config will prohibit remote access to host using ssh.
198
199 HPN config:
200 HPNDisabled
201 HPNBufferSize
202 TcpRcvBuf
203 TcpRcvBufPoll
204 NoneEnabled
205 NoneSwitch
206 cipher MTR-AES-CTR
207 cipher NONE
208
209 OpenSSH HPN is a patch set to OpenSSH providing higher performance under some
210 circumstances, especially for networking.
211 If HPN functionality is needed, install security/openssh from dports.
212
213 CS, EX AND VX DRIVERS REMOVED
214 -----------------------------
215
216 The cs(4), ex(4) and vx(4) drivers have been removed. They were very
217 old and its doubtful they ever worked properly in x86_64 but they were
218 in X86_64_GENERIC, so custom configurations derived from it have to be
219 adjusted.
220
221 +-----------------------------------------------------------------------+
222 +         UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS                +
223 +-----------------------------------------------------------------------+
224
225 AMD REMOVED
226 -----------
227
228 The am-utils automounter suite has been removed. It stopped working
229 at some point and was never fixed. autofs(5) and the associated
230 userland has been brought in from FreeBSD and replaces it.
231
232 AN DRIVER REMOVED
233 -----------------
234
235 The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
236 config file, so any configurations derived from it have to be adjusted.
237
238 /DEV/DRI GROUP CHANGED
239 ----------------------
240
241 The default group assigned to /dev/dri entries has been changed
242 from 'wheel' to 'video' with the id of '44'. If you want to have
243 access to the dri devices please add yourself to the video group
244 with:
245
246 # pw groupmod video -m $USER
247
248 +-----------------------------------------------------------------------+
249 +         UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS                +
250 +-----------------------------------------------------------------------+
251
252 DSCHED REMOVED
253 --------------
254
255 dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
256 in our default kernel config file. So the DSCHED_FQ option has been turned
257 into a no-op for now and can be removed from custom configurations.
258
259 EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
260 -------------------------------------------------
261
262 The est(4) driver has been removed. All CPUs it supported (except one)
263 were 32 bits only. Those who are still using the Core 2 Duo T7500 should
264 report back if there are any issues with this CPU and our regular ACPI
265 P-state support.
266
267 Also, compile_et(1) and com_err(3) have been removed as well. They
268 should have been removed along with kerberos support, back in 2009.
269
270 SEVERAL LOCALES RENAMED
271 -----------------------
272
273 Several locales were using obsolete and misleading names, and thus have
274 been adjusted to current standards. Any users of the following locales
275 need to select alternates:
276
277 DFLY 4.2 locale            DFLY 4.4 alterative locale
278 ---------------            ------------------------------------
279 mn_MN.UTF-8                mn_Cyrl_MN.UTF-8
280 no_NO.UTF-8                nb_NO.UTF-8      or nn_NO.UTF-8
281 no_NO.ISO8859-1            nb_NO.ISO8869-1  or nn_NO.ISO8859-1
282 no_NO.ISO8859-15           nb_NO.ISO8859-15 or nn_NO.ISO8859-15
283 sr_YU.UTF-8                sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
284 sr_YU.ISO8859-5            sr_Cyrl_RS.ISO8859-5
285 sr_YU.ISO8859-2            sr_Latn_RS.ISO8859-2
286 zh_CN.GBK                  zh_Hans_CN.GBK
287 zh_CN.UTF-8                zh_Hans_CN.UTF-8
288 zh_CN.eucCN                zh_Hans_CN.eucCN
289 zh_CN.GB2312               zh_Hans_CH.GB2312
290 zh_CN.GB18030              zh_Hans_CH.GB18030
291 zh_HK.Big5HKSCS            zh_Hant_HK.Big5HKSCS
292 zh_HK.UTF_8                zh_Hant_HK.UTF-8
293 zh_TW.Big5                 zh_Hant_TW.Big5
294 zh_TW.UTF-8                zh_Hant_TW.UTF-8
295
296 +-----------------------------------------------------------------------+
297 +         UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS                +
298 +-----------------------------------------------------------------------+
299
300 BINUTILS 2.25 REPLACES 2.22, PRIMARY
301 ------------------------------------
302
303 The oldest of the two versions of Binutils, version 2.22, was removed
304 and replaced with Binutils 2.25.  It becomes the primary version version
305 of binutils and version 2.24 becomes the alternate.  There are 8 current
306 CVE written against 2.24, so for security reasons version 2.25 should
307 always be used.
308
309 The accepted values of BINUTILSVER are now "binutils225" (default) and
310 "binutils224".  The building of Binutils 2.24 can be prevented by setting
311 NO_ALTBINUTILS=yes in make.conf.
312
313 LOADER OPTIONS CHANGED
314 ----------------------
315
316 Right after the development branch started, the Fred art accompanying the
317 loader menu was improved.  The line between Fred and the menu was removed
318 by default (but can optionally be returned) and the placement shifted as
319 a result.  The drawing was improved, and the colored version was improved,
320 changing the eyes and wing color from white to red.  A new color version
321 of Fred was added, one with a blue scheme.
322
323 The loader menu defaults have changed since release 4.0:  The vertical
324 line was removed, the loader is displayed in color by default*, and the
325 blue scheme is used.
326
327 The loader.conf changes are:
328 loader_color:   option has been removed
329 loader_plain:   option has been added, it changed menu to monochrome
330 fred_is_red:    changes color scheme from blue to red
331 fred_is_blue:   option existed only on 4.1, it has been removed
332 fred_separated: Adds line between Fred and menu (as seen previously)
333
334 * If loader.conf defines "console" as "comconsole" or "console" is defined
335   in the environment as "comconsole" then color will not be displayed,
336   even if loader_plain value is "NO".
337
338 SENDMAIL REMOVED FROM BASE
339 --------------------------
340
341 The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
342 If the system being upgraded is still configured to use the sendmail
343 binaries from base, the "make upgrade" command will fail.
344
345 The administrator must change /etc/mail/mailer.conf to switch the
346 mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
347 command that permanently removes sendmail executables and could
348 potentially break a running mail server.
349
350 Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
351 detailed instructions on how to configure the MTA selection.
352
353 _KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
354 --------------------------------------------
355
356 The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
357 no-ops. They can be removed from custom kernel configurations.
358
359 SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
360 --------------------------------------------
361
362 Many more sound devices may be detected.
363
364 If the default device choosen isn't to your liking, setting the sysctl
365 hw.snd.default_unit to a different number will change it.
366
367 SCTP SUPPORT DROPPED
368 --------------------
369
370 Support for the SCTP protocol has been removed.
371
372 OLD USB DRIVERS REMOVED
373 -----------------------
374
375 The old USB stack, along with the kernel config option "device oldusb"
376 and the make.conf variable "WANT_OLDUSB" have been removed. This means
377 that for custom kernel configuration files which were derived from a
378 GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
379 various (old USB stack specific) devices will now complain about being
380 unknown:
381
382   * oldusb      (obviously)
383   * natausb     (not yet ported to usb4bsd)
384   * rue         (not yet ported to usb4bsd)
385   * ugen        (no longer needed in usb4bsd)
386   * urio        (not yet ported to usb4bsd)
387   * uscanner    (no longer needed in usb4bsd)
388
389 They should be removed or commented out in such custom kernel configs.
390
391 GCC 5
392 -----
393
394 The GCC 4.4 compiler has been retired.  It has been replaced by a GCC 5.1.
395 The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
396 NO_CXX.  The latter was never documented and the latest versions of GCC are
397 partially written in C++ so a C++ compiler is no longer optional.  In
398 practical terms it has not been optional for many years as other base
399 components are also written in C++.  The resource savings by avoiding
400 building Objective-C compiler is so small, the complexity added by NO_OBJC
401 internally was deemed a bad tradeoff so that is the reason for its removal.
402 Also note that no "info" pages are installed with GCC 5.  After this entry
403 was originally written, all info pages were removed from DragonFly.
404
405 GCC 5.1 has been designated as the primary compiler.  As such, there is a
406 new make.conf variable, NO_ALTCOMPILER.  It will block the rebuilding of
407 the designated secondary compiler, GCC 4.7.  However, while DPorts
408 primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
409 if building ports from source is desired, don't block building of the
410 secondary compiler.
411
412 +-----------------------------------------------------------------------+
413 +         UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS                +
414 +-----------------------------------------------------------------------+
415
416 SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
417 -------------------------------------------
418
419 DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
420 the default now (even on single-core systems), both for, like, 21 months.
421 We kept the options around as no-ops as a convenience, to allow people
422 using the same config for the then current release and the then current
423 master. That period is now over, so any configs still having those
424 options have to be adjusted.
425
426 SYSVIPC SYSCALLS MADE NON-OPTIONAL
427 ----------------------------------
428
429 The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
430 now compiled in by default. The options are no-ops for now.
431
432 DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
433 --------------------------------------------------------------------
434
435 The default driver for those controllers is now mrsas(4) due to reports
436 of file system corruption using the mfi(4) driver. The whole issue (and
437 how to deal with potential problems when switching) was explained here:
438
439 http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
440
441 A tunable is provided for letting those controllers still attach via
442 the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
443
444 OLDER NETWORK DRIVERS MOVED TO I386 ONLY
445 ----------------------------------------
446
447 The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
448 and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
449 removed in kernel configs derived from X86_64_GENERIC.
450
451 +-----------------------------------------------------------------------+
452 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
453 +-----------------------------------------------------------------------+
454
455 UPDATE FROM MOST RECENT 3.6
456 ---------------------------
457
458 Versions of 3.6 built before June 25th have a bug where installworld might 
459 crash during installation of the new initrd.  Upgrade to the latest version
460 of 3.6 before updating to 3.8 or later.
461
462 ATM, IPX, NCP AND NWFS SUPPORT DROPPED
463 --------------------------------------
464
465 Support for the IPX and NCP network protocols and for mouting NetWare
466 file systems has been dropped. Dito for ATM protocol support.
467
468 INITRD IMAGES NOW INSTALLED BY DEFAULT
469 --------------------------------------
470
471 An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
472
473 Older images installed under the file name of initrd.img will be removed
474 automatically by the make upgrade process.
475
476 USB4BSD IS NOW THE DEFAULT USB STACK
477 ------------------------------------
478
479 To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
480 replace "device usb" with "device oldusb" in the kernel configuration.
481
482 MORE ISA SUPPORT DROPPED
483 ------------------------
484
485 ISA support has been dropped from the following drivers: adv(4), an(4),
486 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
487 si(4), sn(4), and stg(4).
488
489 +-----------------------------------------------------------------------+
490 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
491 +-----------------------------------------------------------------------+
492
493 ABI CHANGE
494 ----------
495
496 Installed third-party software (dports) will have to be rebuilt after upgrade,
497 or reinstalled from binary packages.
498
499 UPDATING FROM 3.4 TO 3.6
500 ------------------------
501
502 This only applies for this specific upgrade due to locale changes; it is 
503 not needed for upgrades after 3.6.  Please update in this order:
504
505 make buildworld
506 make buildkernel
507 make installworld
508 make installkernel
509 *reboot*
510 make upgrade
511
512 See this mailing list post for details:
513 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
514
515 CYRIX OPTIONS REMOVED
516 ---------------------
517
518 The following Cyrix related options have been removed: CPU_BTB_EN,
519 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
520 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
521 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
522
523 ISA SUPPORT REMOVED FROM RP(4)
524 ------------------------------
525
526 ISA support has been removed from the rp(4) driver. It is now PCI only.
527
528 +-----------------------------------------------------------------------+
529 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
530 +-----------------------------------------------------------------------+
531
532 COMPAT_SUNOS OPTION REMOVED
533 ---------------------------
534
535 The COMPAT_SUNOS option has been removed. It was meant to provide binary
536 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
537
538 ISA SOUND CARD SUPPORT REMOVED
539 ------------------------------
540
541 The following modules have been removed (all for ISA sound cards):
542 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
543
544 GCC 4.7
545 -------
546
547 DragonFly has switched base compilers.  GCC 4.7 is now the default
548 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
549 variable ceases to work now.
550
551 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
552 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
553 highly discouraged.  There are a few packages in pkgsrc that do not build
554 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
555 this time, it is recommended to keep both compilers on the base system.
556
557 SMP OPTION REMOVED
558 ------------------
559
560 The SMP kernel option has been made a no-op. All kernels now feature SMP
561 support. If you have 'options SMP' in your kernel config, you can as well
562 remove it.
563
564 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
565 ---------------------------------------------------------------------------
566
567 The DEVICE_POLLING kernel option has been made a no-op and it has been
568 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
569 kernel config, you need to change it to IFPOLL_ENABLE.
570
571 Also, the KTR_POLLING kernel option has been removed, so it must be
572 removed from kernel configs that have it.
573
574 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
575 ---------------------------------------------------
576
577 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
578 cards will no longer be detected.
579
580 The same has been done for Stallion multiport serial controllers. stli(4)
581 has been completely removed (along with the stlload(8) and stlstty(8)
582 utilities) and stl(4) was changed to support only PCI cards. Similarly,
583 ISA support was removed from cy(4) too. All these drivers are i386 only.
584
585 COMPAT_OLDISA OPTION GONE
586 -------------------------
587
588 The i386 specific COMPAT_OLDISA kernel option has been removed, since
589 nothing needs it anymore.
590
591 +-----------------------------------------------------------------------+
592 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
593 +-----------------------------------------------------------------------+
594
595 APIC_IO OPTION REMOVED
596 ----------------------
597
598 The APIC_IO kernel option is no longer accepted after having been without
599 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
600 If you have 'options APIC_IO' in your kernel config, you'll have to
601 remove it.
602
603 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
604 -----------------------------------------
605
606 The wdog framework is now compiled into our kernels by default, so the
607 options are no longer needed.
608
609 DOSCMD(1) REMOVED
610 -----------------
611
612 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
613 NO_X make.conf option was removed too.
614
615 GCC 4.7
616 -------
617
618 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
619 default compiler in base (default is still GCC 4.4).
620
621 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
622 NO_GCC47 in /etc/make.conf.
623
624 USB4BSD
625 -------
626
627 A new USB stack (from FreeBSD) has been brought in. The following
628 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
629 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
630 and uaudio.
631
632 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
633 be put in make.conf and device "usb4bsd" (quotes needed) has to
634 replace device usb in the kernel config. After that, a full
635 build/install/upgrade cycle is needed.
636
637 Note that this is experimental and incomplete, but we are interested
638 in hearing about issues with it, of course.
639
640 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
641 ---------------------------------------------
642
643 ISA adapter support was dropped from the aic(4) driver.
644
645 +-----------------------------------------------------------------------+
646 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
647 +-----------------------------------------------------------------------+
648
649 SEVERAL ISA DRIVERS REMOVED
650 ---------------------------
651
652 The following ISA only drivers have been removed along with a couple of
653 associated userland tools:
654
655 aha(4)
656 asc(4) & sasc(1)
657 ctx
658 dgb(4)
659 el(4)
660 gpib
661 gsc(4) & sgsc(1)
662 ie(4)
663 labpc(4)
664 le(4)
665 mse(4)
666 rc(4)
667 rdp(4)
668 spigot
669 tw(4) & xten(1) & xtend(8)
670 wl(4) & wlconfig(8)
671 wt(4)
672
673 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
674 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
675 file.
676
677 If buildkernel complains about any of these drivers, just remove them
678 from your kernel configuration.
679
680 BINUTILS 2.20
681 -------------
682 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
683 values of BINUTILSVERS are now binutils221 and binutils222 (default).
684
685 BUILDWORLD/-KERNEL PARALLELIZATION WORK
686 ---------------------------------------
687 Due to changes in the way we build with more than one make job, you
688 will have to update install(1) and mkdir(1) prior to buildworld if you
689 want to build with 'make -j':
690
691 cd /usr/src/usr.bin/xinstall; make; make install; make clean
692 cd /usr/src/bin/mkdir; make; make install; make clean
693
694 DMA(8) UPGRADE
695 --------------
696 dma(8) has been upgraded to v0.7 which no longer supports the
697 /etc/dma/virtusertable. Some of its functionality has been replaced
698 with the MASQUERADE keyword and the EMAIL environment variable (see
699 the dma(8) manual page).
700
701 +-----------------------------------------------------------------------+
702 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
703 +-----------------------------------------------------------------------+
704
705 GCC 4.4 & BINUTILS 2.21
706 -----------------------
707
708 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
709 been made DragonFly's default Binutils.
710
711 That means that any settings that set CCVER to 'gcc44' are not needed
712 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
713 GCC 4.1.
714
715 It also means that 'binutils221' as a value for BINUTILSVER has no
716 effect anymore. 2.17 has been removed and 'binutils220' is available
717 as an option.
718
719 The NO_GCC44 option has been removed and will not affect the build
720 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
721 building in a similar fashion.
722
723 Note that you must do a full buildworld/buildkernel for upgrading.
724
725 pkg_radd settings
726 -----------------
727
728 The config file for pkg_radd has moved from /etc/settings.conf to 
729 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
730 if this is needed.  This warning only applies if /etc/settings.conf 
731 exists.  pkg_radd will continue to work with defaults.
732
733 +-----------------------------------------------------------------------+
734 +         20100927                                                      +
735 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
736 +-----------------------------------------------------------------------+
737
738 OpenSSL
739 --------
740
741 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
742 This shouldn't break any 3rd-party software, but you'll need to recompile your
743 3rd-party software if you want it to link against the new version of OpenSSL.
744
745 Loader
746 -------
747
748 A new loader (dloader) has been added which better handles booting from
749 multiple kernel/module versions.
750
751 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
752
753         cd /usr/src
754         make buildworld
755         make installworld
756         make upgrade
757         make buildkernel KERNCONF=<KERNELNAME>
758         make installkernel KERNCONF=<KERNELNAME>
759
760 Note that you must installworld and run the 'upgrade' target before
761 installing the new kernel.
762
763 BIND
764 -----
765
766 BIND has been removed from the base system.  The ldns and drill tools have 
767 been added for basic functionality.  Use 'drill' where you would normally 
768 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
769 net/bind95, net/bind96, or net/bind97 as of this writing.
770
771 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
772 include BIND as a pkgsrc package.
773
774 +-----------------------------------------------------------------------+
775 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
776 +                               GENERAL                                 +
777 +-----------------------------------------------------------------------+
778
779 Instructions on how to obtain and maintain DragonFly source code using git
780 are in the development(7) manual page.
781
782 To upgrade a DragonFly system from sources you run the following sequence:
783
784         cd /usr/src
785         make buildworld
786         make buildkernel KERNCONF=<KERNELNAME>
787         make installkernel KERNCONF=<KERNELNAME>
788         make installworld
789
790 You will also want to run the 'upgrade' target to upgrade your /etc and the
791 rest of your system.  The upgrade target is aware of stale files created by
792 older DragonFly installations and should delete them automatically.
793
794         make upgrade
795
796 See the build(7) manual page for further information.
797
798 Once you've done a full build of the world and kernel you can do incremental
799 upgrades of either by using the 'quickworld' and 'quickkernel' targets
800 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
801 the quick targets, try updating your repo first, and then a full buildworld
802 and buildkernel as shown above, before asking for help.
803
804 +-----------------------------------------------------------------------+
805 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
806 +-----------------------------------------------------------------------+
807
808 In 2.1 kernel and modules has moved to boot directory.  For most cases
809 this is handled automatically by 'make upgrade'.  A few cases needs manual
810 intervention:
811
812  * When installing a kernel without first doing a make buildworld,
813    installworld and upgrade to the same DESTDIR as kernel:
814    make DESTDIR/boot directory and move kernel and modules into this boot
815    directory; also move kernel.old and modules.old.
816    Typical example is vkernel(7), use (no modules used):
817
818         cd /var/vkernel
819         mkdir boot
820         chflags noschg kernel
821         mv kernel kernel.old boot
822         chflags schg boot/kernel
823         
824  * When using a boot-only partition, /boot/loader.rc needs to be edited:
825    delete occurrences of '/boot/'.
826    These occurences can normally be deleted in any case, see loader(8).
827
828 +-----------------------------------------------------------------------+
829 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
830 +-----------------------------------------------------------------------+
831
832 In 1.9 major changes to the disk management infrastructure have taken
833 place.  make upgrade may not catch all of your disk devices in /dev,
834 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
835 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
836 and MAKEDEV no longer exists.
837
838 The biggest changes in 1.9 are:
839
840 (1) That whole-slice devices such as da0s1 no longer share the same device
841     id as partition c devices such as da0s1c.
842
843 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
844     with no snooping or reserved sectors.  Consequently you cannot run
845     disklabel on this device.  Instead you must run disklabel on a
846     whole-slice device.
847
848 (3) The 'compatibility' partitions now use slice 0 in the device name,
849     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
850     accessing the disklabel for the compatibility partitions must be
851     done via slice 0 (da0s0).
852
853 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
854     and CCD now run through the disk management layer and are assigned
855     real disk management devices.   VN and CCD in particular do not usually
856     use a MBR and disklabels must be accessed through the compatibility
857     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
858     don't name it 'ccd0s0' in the config file.
859
860 Generally speaking, you have to get used to running fdisk and disklabel on
861 the correctly specified device names.  A lot of the wiggle, such as running
862 disklabel on a partition, has been removed.
863
864 +-----------------------------------------------------------------------+
865 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
866 +-----------------------------------------------------------------------+
867
868 > Kerberos IV
869 -------------
870
871 Kerberos IV (eBones) was removed from the tree, please consider moving to
872 Kerberos 5 (Heimdal).
873
874 > Package Management System
875 ---------------------------
876
877 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
878 management system.  The necessary tools to build and maintain packages
879 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
880 directories are in your PATH variable.
881
882 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
883 the tarball from NetBSD:
884
885         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
886         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
887
888 This tree can then be kept up to date with cvs update:
889
890         cd /usr/pkgsrc; cvs up
891
892 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
893 build and install the pkgsrc bootstrap manually:
894
895         cd /usr/pkgsrc/bootstrap
896         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
897
898 +-----------------------------------------------------------------------+
899 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
900 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
901 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
902 +-----------------------------------------------------------------------+
903
904 The compatibility shims for the build environment have been removed, you
905 have to update to DragonFly 1.2 release branch first.
906
907 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
908 The existing configuration can be converted using /etc/pam.d/convert.sh.
909 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
910 the pam_skey.so module was retired, you have to remove it manually from
911 your configuration, when you convert it.
912
913 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
914 ---------------------
915
916 The following users may be missing from your password file.  Use vipw and
917 add any that are missing:
918
919 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
920 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
921
922 The following groups may be missing from your group file.  Use vi /etc/group
923 and add any that are missing:
924
925 smmsp:*:25:
926 authpf:*:63:
927 _pflogd:*:64:
928
929
930 > Upgrading to DragonFly from FreeBSD
931 ---------------------
932
933 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
934 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
935 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
936 make depend information, it starts from scratch, so no pre-cleaning of the
937 object hierarchy is necessary.
938
939         # get the CVS repository (it is placed in /home/dcvs, 500MB).
940         # Please use the -h option and a mirror site to pull the 
941         # initial repository, but feel free to use the main repository
942         # machine to pull updates.
943         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
944         # install the source from the CVS hierarchy (remove preexisting
945         # FreeBSD src first) (500MB)
946         cd /usr
947         rm -rf src
948         cvs -R -d /home/dcvs checkout -P src
949
950         # build it (500MB used in /usr/obj)
951         #
952         cd /usr/src
953         make buildworld
954         make buildkernel KERNCONF=<KERNELNAME>
955
956 Once you have built DragonFly you have to install it over FreeBSD.  Since
957 DragonFly does not track changes made by FreeBSD to its include file 
958 hierarchy and include file pollution can cause all sorts of unexpected
959 compilation issues to come up, it is best to wipe your include hierarchy
960 prior to installing DragonFly.  Note that you should not wipe any installed
961 FreeBSD header files or binaries until after you have successfully completed
962 the build steps above.
963
964         rm -rf /usr/include
965         mkdir /usr/include
966         make installkernel KERNCONF=<KERNELNAME>
967         make installworld
968
969 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
970 will unconditionally upgrade the /etc files that sysops do not usually
971 mess around with, such as the files in /etc/rc.d.  It will also remove any
972 obsolete files such as utilities and manpages that have been removed from
973 the system since the version you're coming from.  If you are unsure we 
974 recommend that you make a backup of at least your /etc before applying
975 this step.  Note that DragonFly's RC system is basically RCNG from
976 FreeBSD-5, but there are some differences in the contents of the RC files.
977
978         make upgrade
979
980 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
981 Doing so might leave your system in an unusable state.
982
983 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
984 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
985 report these files to the DragonFly developers so that they can be added to
986 the 'upgrade' target.
987